﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;
namespace ModbusDemo.Common
{
    public static class ModualAlarm
    {
        public const ushort usChannelNumber = 8;
        private const string sAlarmTopic = "Witium/WTDS78X/66666666/Alarm";
        public static string sAlarmJson;
        public static string sAlarmJsonPackage;
        //private IMqttClient mqttClient = null;
        public enum eAlarmCode : ushort
        {
            ChannelNoError = 0,
            ChannelCommunError = 1,
            ChannelCollectDataError = 2,
            ChannelDataRespError = 4,
            ChannelDataChangeError = 8
        }
        public static void vSetAlarmList(ushort usAddress, ushort[] usChannel, ushort[] usChannelAlarmcode)
        {
            ushort i = 0;
            Hashtable hMqtttAlarmMap = new Hashtable();
            hMqtttAlarmMap.Add("addr", usAddress.ToString());
            string sAlarm = "alm";
            foreach (ushort usdata in usChannelAlarmcode)
            {
                hMqtttAlarmMap.Add(sAlarm + i, usChannelAlarmcode[i]);
                i++;
            }
            hMqtttAlarmMap.Add("ts", Form1.GetTimeStamp());
            if (sAlarmJson != "[")
            {
                sAlarmJson += ",";
            }
            sAlarmJson += JsonConvert.SerializeObject(hMqtttAlarmMap);

        }
        public static async Task vPublishAlarmPackageJson(IMqttClient mqttClient)
        {
            var message = new MqttApplicationMessageBuilder()
                                .WithTopic(sAlarmTopic)
                                .WithPayload(sAlarmJson)
                                .WithAtMostOnceQoS()
                                .WithRetainFlag(false)
                                .Build();
            await mqttClient.PublishAsync(message);
        }
    }
}
